"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const tsioc_1 = require("tsioc");
const util_1 = require("./util");
const restults_1 = require("./restults");
const index_1 = require("./index");
/**
 * Base Controller.
 *
 * @export
 * @class Controller
 */
let BaseController = class BaseController {
    constructor() {
    }
    /**
     * respone view result.
     *
     * @param {string} viewName
     * @param {object} [model]
     * @returns
     * @memberof BaseController
     */
    view(viewName, model) {
        return new restults_1.ViewResult(viewName, model);
    }
    /**
     * respone file result.
     *
     * @param {(string | Buffer | Stream)} file
     * @param {string} [contentType]
     * @param {string} [fileDownloadName]
     * @returns
     * @memberof BaseController
     */
    file(file, contentType, fileDownloadName) {
        return new restults_1.FileResult(file, contentType, fileDownloadName);
    }
    /**
     * respone redirect result.
     * Perform a 302 redirect to `url`.
     *
     * The string "back" is special-cased
     * to provide Referrer support, when Referrer
     * is not present `alt` or "/" is used.
     *
     * Examples:
     *
     *    this.redirect('back');
     *    this.redirect('back', '/index.html');
     *    this.redirect('/login');
     *    this.redirect('http://google.com');
     * @param {string} url
     * @param {string} [alt]
     * @returns
     * @memberof BaseController
     */
    redirect(url, alt) {
        return new index_1.RedirectResult(url, alt);
    }
    /**
     * respone json result.
     *
     * @param {object} data
     * @returns
     * @memberof BaseController
     */
    json(data) {
        return new index_1.JsonResult(data);
    }
};
__decorate([
    tsioc_1.Inject(util_1.symbols.IContext),
    __metadata("design:type", Object)
], BaseController.prototype, "context", void 0);
BaseController = __decorate([
    tsioc_1.Injectable,
    __metadata("design:paramtypes", [])
], BaseController);
exports.BaseController = BaseController;

//# sourceMappingURL=sourcemaps/BaseController.js.map
