"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tsioc_1 = require("tsioc");
const util_1 = require("util");
function createCorsDecorator(name, adapter, metadataExtends) {
    return tsioc_1.createClassMethodDecorator(name, args => {
        if (adapter) {
            adapter(args);
        }
        args.next({
            match: (arg) => util_1.isArray(arg) || util_1.isString(arg),
            setMetadata: (metatdata, arg) => {
                if (util_1.isString(arg)) {
                    metatdata.allowMethods = arg;
                }
                else {
                    let allowMethods = arg;
                    metatdata.allowMethods = allowMethods.filter(m => !util_1.isUndefined(m) && m !== null);
                }
            }
        });
        args.next({
            match: (arg) => util_1.isNumber(arg),
            setMetadata: (metatdata, arg) => {
                metatdata.maxAge = arg;
            }
        });
        args.next({
            match: (arg) => util_1.isArray(arg),
            setMetadata: (metatdata, arg) => {
                let allowHeaders = arg;
                metatdata.allowHeaders = allowHeaders.filter(h => !!h);
            }
        });
    }, metadataExtends);
}
exports.createCorsDecorator = createCorsDecorator;
exports.Cors = createCorsDecorator('Cors');

//# sourceMappingURL=../sourcemaps/decorators/Cors.js.map
