"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const middlewares_1 = require("./middlewares");
const util_1 = require("./util");
const router_1 = require("./router");
const BaseController_1 = require("./BaseController");
function registerDefaults(container) {
    container.register(util_1.symbols.ContentMiddleware, middlewares_1.DefaultContentMiddleware);
    container.register(util_1.symbols.ContextMiddleware, middlewares_1.DefaultContextMiddleware);
    container.register(util_1.symbols.JsonMiddleware, middlewares_1.DefaultJsonMiddleware);
    container.register(util_1.symbols.LogMiddleware, middlewares_1.DefaultLogMiddleware);
    container.register(util_1.symbols.SessionMiddleware, middlewares_1.DefaultSessionMiddleware);
    container.register(util_1.symbols.BodyParserMiddleware, middlewares_1.DefaultBodyParserMiddleware);
    container.register(util_1.symbols.ViewsMiddleware, middlewares_1.DefaultViewsMiddleware);
    container.register(util_1.symbols.CorsMiddleware, middlewares_1.DefaultCorsMiddleware);
    container.register(router_1.ModelParser);
    container.register(BaseController_1.BaseController);
    container.register(router_1.Router);
}
exports.registerDefaults = registerDefaults;

//# sourceMappingURL=sourcemaps/registerDefaults.js.map
