"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const tsioc_1 = require("tsioc");
const util_1 = require("util");
const decorators_1 = require("../decorators");
let ModelParser = class ModelParser {
    constructor(container) {
        this.container = container;
    }
    isModel(type) {
        return Reflect.hasOwnMetadata(decorators_1.Model.toString(), type);
    }
    parseModel(type, objMap) {
        let meta = tsioc_1.getPropertyMetadata(decorators_1.Field, type);
        let result = this.container.get(type);
        for (let n in meta) {
            let propmetas = meta[n];
            if (propmetas.length) {
                if (!util_1.isUndefined(objMap[n])) {
                    let propmeta = propmetas.find(p => !!p.type);
                    let reqval = objMap[n];
                    let parmVal;
                    if (this.isBaseType(propmeta.type)) {
                        parmVal = this.parseBaseType(propmeta.type, reqval);
                    }
                    else if (tsioc_1.isClass(propmeta.type) && this.isModel(propmeta.type)) {
                        parmVal = this.parseModel(propmeta.type, reqval);
                    }
                    result[n] = parmVal;
                }
            }
        }
        return result;
    }
    parseBaseType(type, paramVal) {
        let val;
        if (type === String) {
            val = String(paramVal);
        }
        else if (type === Boolean) {
            val = new Boolean(paramVal);
        }
        else if (type === Number) {
            val = parseFloat(paramVal);
        }
        else if (type === Date) {
            val = new Date(paramVal);
        }
        else {
            val = paramVal;
        }
        return val;
    }
    isBaseType(p) {
        if (!tsioc_1.isToken(p)) {
            return true;
        }
        if (p === Boolean || p === String || p === Number) {
            return true;
        }
        return false;
    }
};
ModelParser = __decorate([
    tsioc_1.Singleton,
    __param(0, tsioc_1.Inject(tsioc_1.symbols.IContainer)),
    __metadata("design:paramtypes", [Object])
], ModelParser);
exports.ModelParser = ModelParser;

//# sourceMappingURL=../sourcemaps/router/ModelParser.js.map
