"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const tsioc_1 = require("tsioc");
const decorators_1 = require("../decorators");
const ControllerRoute_1 = require("./ControllerRoute");
let RouteBuilder = class RouteBuilder {
    constructor() {
    }
    build(router, ...controllers) {
        let root = router.getRoot();
        let contrkey = decorators_1.Controller.toString();
        controllers.forEach(ctrl => {
            if (tsioc_1.isClass(ctrl)) {
                let ctrlmetadatas = tsioc_1.getTypeMetadata(contrkey, ctrl);
                ctrlmetadatas.forEach(ctlmeta => {
                    if (!ctlmeta) {
                        return;
                    }
                    let prefix = ctlmeta.routePrefix;
                    if (prefix && !/^\//.test(prefix)) {
                        prefix = '/' + prefix;
                    }
                    let route = root.match(prefix);
                    let ctrlRoute = new ControllerRoute_1.ControllerRoute(prefix, ctrl);
                    if (route.isEmpty()) {
                        root.add(new ControllerRoute_1.ControllerRoute(prefix, ctrl));
                    }
                    else {
                        route.add(new ControllerRoute_1.ControllerRoute(prefix, ctrl));
                    }
                });
            }
        });
        return root;
    }
};
RouteBuilder = __decorate([
    tsioc_1.Injectable,
    __metadata("design:paramtypes", [])
], RouteBuilder);
exports.RouteBuilder = RouteBuilder;

//# sourceMappingURL=../sourcemaps/router/RouteBuilder.js.map
