"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const Application_1 = require("../Application");
const Configuration_1 = require("../Configuration");
const decorators_1 = require("../decorators");
const RootRoute_1 = require("./RootRoute");
const RouteBuilder_1 = require("./RouteBuilder");
const util_1 = require("../util");
const compose = require('koa-compose');
let Router = class Router {
    constructor(builder, app, config) {
        this.builder = builder;
        this.app = app;
        this.config = config;
        this.root = new RootRoute_1.RootRoute(config.routePrefix);
    }
    routes(map) {
        this.root.add(map);
    }
    register(...controllers) {
        this.builder.build(this, ...controllers);
    }
    setup() {
        this.app.use(async (ctx, next) => {
            if (!ctx.status || ctx.status === 404) {
                return this.root.navigating(this.app.container, ctx, next);
            }
        });
        // let stack = [];
        // stack.push(async (ctx, next) => {
        //     if (!ctx.status || ctx.status === 404) {
        //         return this.root.options(this.app.container, ctx, next);
        //     }
        // });
        // stack.push(async (ctx, next) => {
        //     if (!ctx.status || ctx.status === 404) {
        //         return this.root.navigating(this.app.container, ctx, next);
        //     }
        // })
        // this.app.use(compose(stack));
    }
    getRoot() {
        return this.root;
    }
};
Router = __decorate([
    decorators_1.Middleware(util_1.symbols.RouterMiddleware),
    __metadata("design:paramtypes", [RouteBuilder_1.RouteBuilder, Application_1.Application, Configuration_1.Configuration])
], Router);
exports.Router = Router;

//# sourceMappingURL=../sourcemaps/router/Router.js.map
